COM_AddCommand("debug",function(player, var1)
	if var1 == 1 then
		player.debug = true
	else
		player.debug = false
	end
end)

//Help menu
COM_AddCommand("battlehelp", function(player, var1, var2)
	local t = ""
	if var1 == nil then
		t = "\x85 battlehelp: \x80 console,melee,actions,matchrules,tagrules,ctfrules,versioninfo"
	elseif var1 == "versioninfo" then
		t = "\x82 BattleMod (v"..CBW_Battle.VersionNumber..") \x80 written by CobaltBW. Last updated "..CBW_Battle.VersionDate
	elseif var1 == "console" and var2 == nil then
		t = "\x85 console: \x80 autoaim,paneltime,panelwaittime,prepaneltime"
	elseif var1 == "console" and var2 == "autoaim" then
		t = "\x85 autoaim: \x80 Enables/disables automatic aiming for certain special moves."
	elseif var1 == "console" and var2 == "paneltime" then
		t = "\x85 paneltime: \x80 Amount of time (in seconds) before a score panel disappears in Battle Mode."
	elseif var1 == "console" and var2 == "panelwaittime" then
		t = "\x85 panelwaittime: \x80 Amount of time (in seconds) before a score panel reappears in Battle Mode."
	elseif var1 == "console" and var2 == "prepaneltime" then
		t = "\x85 prepaneltime: \x80 Amount of time (in seconds) after the match starts that a score panel will appear in Battle Mode."
	elseif var1 == "melee" then
		t = "\x85 Melee: \x80 All characters can deal damage with their standard attacks."+
		"\nIf two players attack each other at the same time, the player with the least amount of momentum will momentarily lose control over their character."+
		"\nSome attacks, such as Tails' propellor attack and Knuckles' gliding fists, have lower or higher priority depending on their angle of attack."
	elseif var1 == "actions" and var2 == nil then
		t = "\x85 Actions: \x80 All characters can use a special move by pressing \x82 FIRE \x80 with at least 10 rings."+
			"\nType \x82 battlehelp actions <skin> \x80 for a description of each character's ability set. Note that some custom skins may not have abilities."
	elseif var1 == "actions" and var2 == "sonic" then
		t = "\x85 Sonic: \x80 Press \x82 FIRE \x80 with 10 rings on the ground to perform a high jump. Press \x82 FIRE \x80 with 10 rings in the air to perform a ground pound which can damage nearby enemies."
	elseif var1 == "actions" and var2 == "tails" then
		t = "\x85 Tails: \x80 Press \x82 FIRE \x80 with 10 rings to spawn a flying robot sentry. Press \x82 FIRE \x80 again to send the robot sentry to attack the nearest target."
	elseif var1 == "actions" and var2 == "knuckles" then
		t = "\x85 Knuckles: \x80 Press \x82 FIRE \x80 with 10 rings to dig into any surface. If used in the air, Knuckles will strike downwards into the ground. Knuckles will slowly consume rings while burrowed. Press \x82 FIRE \x80 again to resurface and send damaging rock debris in all directions."
	elseif var1 == "actions" and var2 == "amy" then
		t = "\x85 Amy: \x80 Press \x82 FIRE \x80 with 10 rings to release a charm beam, which will shrink and disable enemies and shield teammates on contact."
	elseif var1 == "actions" and var2 == "fang" then
		t = "\x85 Fang: \x80 Press \x82 FIRE \x80 with 10 rings to throw a bomb. Bombs will linger for a short while and explode on contact with players."
	elseif var1 == "actions" and var2 == "metalsonic" then
		t = "\x85 MetalSonic: \x80 Press and hold \x82 FIRE \x80 with at least 10 rings to charge up an energy blast. Holding the \x82 FIRE \x80 button for longer will cost additional rings, but it will increase the blast range of the attack."
	elseif var1 == "tagrules" then
		t = "\x85 Egg Robo Tag: \x80 All players who become IT are turned into egg robos! Players can also bump into each other, so don't be complacent with group hiding spots!"
	elseif var1 == "matchrules" then
		t = "\x85 Battle Mode: \x80 Players score points on each other by landing melee and special attacks. If panels are enabled, a random panel will appear on the map which gradually reward points to whoever last touched it."
	elseif var1 == "ctfrules" then
		t = "\x85 Battle CTF: \x80 Players must strategically use special attacks and melee to defend their flag from one another. Chase behind flagrunners to gain a backdraft boost and intercept them!"
	end
	CONS_Printf(player,t)
end,0)

//Autoaim toggle
COM_AddCommand("autoaim", function(player)
	if not(player and player.valid and player.truemo) then
		CONS_Printf(player,"Please wait until inside a game to use this command.")
		return
	end
	if not(player.autoaim == 0) then
		player.autoaim = 0
		CONS_Printf(player,"Auto aim disabled.")
	else
		player.autoaim = 1
		CONS_Printf(player,"Auto aim enabled.")
	end
end,0)

//Panel Time
KingPanel.CV_PanelTime = CV_RegisterVar{
	name = "paneltime",
	defaultvalue = 45,
	flags = CV_NETVAR,
	PossibleValue = {MIN = 10, MAX = 255}
}
KingPanel.CV_PanelWaitTime = CV_RegisterVar{
	name = "panelwaittime",
	defaultvalue = 60,
	flags = CV_NETVAR,
	PossibleValue = {MIN = 10, MAX = 255}
}
KingPanel.CV_PrePanelTime = CV_RegisterVar{
	name = "prepaneltime",
	defaultvalue = 45,
	flags = CV_NETVAR,
	PossibleValue = {MIN = 10, MAX = 255}
}

COM_AddCommand("removepanel",function(player, panel)
	if player != server then CONS_Printf(player,"Only the server can use this command") return end
	if KingPanel.kingpanelmode == false then CONS_Printf(player,"King of the Panel mode is not currently in session.") return end
	if panel != nil then panel = tonumber($) end
	if panel != nil and panel != 0 /*and panel <= #KingPanel.panel_id*/ then
		local id = KingPanel.panel_id[panel]
		if not(id and id.valid) then
			CONS_Printf(player,"Error: panel id for type "..panel.." does not exist on current map, or it has already been removed.")
			return
		else
-- 			P_RemoveMobj(id)
			id.target = nil
			id.ctfteam = 0
			id.flags = ($|MF_NOCLIPTHING)&~MF_SPECIAL
			id.flags2 = $|MF2_DONTDRAW
			KingPanel.panel_id[panel] = nil
			print("Panel id for type "..panel.." has been removed.")			
		return end
	end
	//Default
	CONS_Printf(player,"removepanel [1-6], removes panel id from the stage") return
end)