CBW_Battle.Action.Sentry=function(mo,doaction)
	local sentry = mo.player.sentry
	//Run checks
	if mo.player.gotflag then 
		if sentry and sentry.valid then
			sentry.tracer = nil
			mo.player.sentry = nil
		end
		return
	end
	
	if P_PlayerInPain(mo.player) then
		return
	end
	
	if sentry and not(sentry.valid) then
		mo.player.sentry = nil
	end
	
	//Action Info
	if not(sentry) then
		mo.player.actiontext = "Spawn Sentry"
		mo.player.actionrings = 10
	else
		mo.player.actiontext = "Seek Target"
		mo.player.actionrings = 0
	end
	doaction = CBW_Battle.CheckRings(mo.player,$)

	//Spawn Sentry
	if doaction == 1 and sentry == nil then
		sentry = P_SpawnMobj(mo.x,mo.y,mo.z,MT_BUZZBUDDY)
		if sentry and sentry.valid then
			mo.player.sentry = sentry
			sentry.target = mo
			sentry.scale = $/2
			sentry.ctfteam = mo.player.ctfteam
			CBW_Battle.PayRings(mo.player)
			mo.player.actioncooldown = TICRATE

			S_StartSound(sentry,sfx_s3kb8)
			for l = 0,7
				P_SpawnParaloop(mo.x,mo.y,mo.z+mo.height/2,128*mo.scale,16,MT_NIGHTSPARKLE,mo.angle+45*l*ANG1,nil,1)
			end			
		end
	return end
	//Command Sentry to Attack
	if doaction == 1 and sentry and sentry.valid then
		if not(sentry.tracer) and not(sentry.fuse) then
			local near = CBW_Battle.GetNearestPlayer(mo,90,-1)
			if not(near) then
				near = CBW_Battle.SearchObject(mo,mo.angle,90,512*FRACUNIT,MF_ENEMY|MF_BOSS|MF_MONITOR,sentry,-1)
			else
				near = near.mo
			end
			if near and near.valid then
				sentry.tracer = near
				sentry.fuse = 25
				S_StartSound(sentry,sfx_s3kc5s)
				sentry.flags = $&~MF_NOCLIP
			return end
		end
	end
end

CBW_Battle.BuzzBuddyThinker=function(mo)
	if not(mo.health) then return end
	//Do color
	if mo.target then
		mo.color = mo.target.color
	end
	if mo.fuse and mo.target then
		mo.color = P_RandomRange(1,MAXSKINCOLORS-1)
	end
	//Air Drag
	local spd = FixedHypot(mo.momx,mo.momy)
	local dir = R_PointToAngle2(0,0,mo.momx,mo.momy)
-- 	P_Thrust(mo,dir,min(spd,mo.scale))
	if mo.target and mo.target.flags2&MF2_OBJECTFLIP then
		mo.flags2 = $|MF2_OBJECTFLIP
	else
		mo.flags2 = $&~MF2_OBJECTFLIP
	end
	if mo.target and mo.target.valid and mo.target.health and mo.target.player and CBW_Battle.ActionChar[mo.target.player.actiontype] == CBW_Battle.Action.Sentry and mo.target.player.sentry == mo then
		local dist = R_PointToDist2(mo.x,mo.y,mo.target.x,mo.target.y)
		local angle = R_PointToAngle2(mo.x,mo.y,mo.target.x,mo.target.y)
		local zdist = mo.target.z+mo.target.height*2*P_MobjFlip(mo) - (mo.z+mo.height)
		local water = CBW_Battle.WaterFactor(mo)
		if not(mo.fuse) then
			//Follow
			if dist > 64*mo.scale then
				P_InstaThrust(mo,angle,max(0,(dist-64*FRACUNIT/water)/8))
			end
			if abs(zdist) > 2*FRACUNIT
				mo.momz = max(min(4*FRACUNIT/water,$+zdist/16/water),-4*FRACUNIT/water)
			end
			mo.angle = angle
		//Attack ready; V-Align to tracer
		elseif mo.tracer and mo.tracer.valid then
			mo.angle = R_PointToAngle2(mo.x,mo.y,mo.tracer.x,mo.tracer.y)
			mo.momz = (mo.tracer.z-mo.z)/8/water
			P_InstaThrust(mo,R_PointToAngle2(0,0,mo.momx,mo.momy),FixedHypot(mo.momx,mo.momy)/10*9)
		end
		//Smoketrail
		if not(mo.flags&MF_NOCLIP) and not(mo.fuse&3) then
			local x = mo.x+P_ReturnThrustX(nil,mo.angle+180,mo.scale*3)
			local y = mo.y+P_ReturnThrustY(nil,mo.angle+180,mo.scale*3)
			P_SpawnMobj(x,y,mo.z+mo.height,MT_SPINDUST)
		end
	elseif (mo.flags&MF_SPECIAL)
		then
		//Self-destruct timer
		mo.fuse = TICRATE
		mo.flags = $&~(MF_NOCLIP|MF_SPECIAL|MF_ENEMY|MF_NOGRAVITY)
		mo.momz = 0
		mo.momx = 0
		mo.momy = 0		
	end
end

CBW_Battle.BuzzBuddyFuse=function(mo)
	//Kill object if no owner
	if not(mo.flags&MF_SPECIAL) then
		P_KillMobj(mo)
		return true
	end
	//Thrust toward target
	if mo.tracer and mo.tracer.valid then
		local water = CBW_Battle.WaterFactor(mo)
		P_InstaThrust(mo,mo.angle,mo.scale*60/water)
		mo.fuse = TICRATE*water
		mo.tracer = nil
		P_SetObjectMomZ(mo,FRACUNIT/water)
		S_StartSound(mo,sfx_zoom)
	else //Reset state
		mo.flags = $|MF_NOCLIP
	end
	
	return true
end

CBW_Battle.BuzzBuddyTouch=function(buzzmo,othermo)
	//Not a valid target
	if not(buzzmo.target and buzzmo.target.valid) then return end
	//Enemy or opposing player
	if not(buzzmo.target.player) or not(othermo.player) or CBW_Battle.MyTeam(othermo.player,buzzmo.target.player) == false then 
		//We're attacking if MF_NOCLIP is unflagged
		if not(buzzmo.flags&MF_NOCLIP) and (not(othermo.player) or CBW_Battle.PlayerCanBeDamaged(othermo.player)) then
			P_DamageMobj(othermo,buzzmo,buzzmo.target)
-- 			return false
		end
		//Do rest of code
		return
	end
	//Default (for friendly collisions)
	return true
end

CBW_Battle.BuzzBuddyDamage = function(buzzmo,inflictor,source)
	if buzzmo and buzzmo.valid and buzzmo.target and buzzmo.target.valid and buzzmo.target.player
		if source and source.valid and source.player
			if CBW_Battle.MyTeam(buzzmo.target.player,source.player)
				then 
				return false //Don't damage if a projectile is on our team
			end
		elseif inflictor and inflictor.valid and inflictor.player	
			if CBW_Battle.MyTeam(buzzmo.target.player,inflictor.player)
				then
				return false //Don't damage if inflictor is on our team
			end
		end
	end
end

CBW_Battle.BuzzBuddyCollide = function(buzzmo,othermo)
	if not(buzzmo.valid and othermo.valid) then return end
	if buzzmo.z > othermo.z+othermo.height then return end
	if othermo.z > buzzmo.z+buzzmo.height then return end
	if not(othermo.flags&(MF_MONITOR|MF_ENEMY|MF_BOSS) and othermo.health) then return end
	CBW_Battle.BuzzBuddyTouch(buzzmo,othermo)
end
