local TF_GRAY = 1
local TF_YELLOW = 2
local TF_RED = 3
local TF_BLINK = 4

//-Special Moves-
local function actionhud(v, player, cam)
	if player.playerstate != PST_LIVE then return end
	if player.actionallowed != true then return false end
	if player.actiontext == nil then return end
	if G_TagGametype() and leveltime < 30*TICRATE then return end
	
	local blink = false
	local xoffset = 16
	local yoffset = 58
	local flags = V_HUDTRANS|V_SNAPTOTOP|V_SNAPTOLEFT|V_PERPLAYER
	local text
	local textflags
	if player.actiontextflags2 != nil then
		textflags = player.actiontextflags2
	else
		textflags = player.actiontextflags
	end
	
	if textflags&TF_BLINK and leveltime&2 then return end
	
	textflags = $&~TF_BLINK
	
	if player.actioncooldown or (player.actionstate == 0 and player.actionrings > player.rings) then
		textflags = $|TF_GRAY
	end
	
	if player.actionstate and player.actionrings then
		textflags = $|TF_YELLOW
	end
	
	if player.actiontext2 != nil then
		text = player.actiontext2
	else
		text = player.actiontext
	end
	if textflags == TF_GRAY then
		text = "\x86"+$
	elseif textflags == TF_YELLOW then
		text = "\x82"+$
	elseif textflags == TF_RED then
		text = "\x85"+$
	else
		text = "\x80"+$
	end
	if player.actionrings then 
		text = "\x82"+player.actionrings+"\x80 "+$
	end

	//Draw
	if not(blink) then
		v.drawString(xoffset,yoffset,text,flags)
	end
	//DrawDebug
-- 	v.drawString(xoffset,yoffset+8,"actiontype: "+player.actiontype,flags)
-- 	v.drawString(xoffset,yoffset+16,"actionstate: "+player.actionstate,flags)
-- 	v.drawString(xoffset,yoffset+24,"actiontime: "+player.actiontime,flags)
-- 	v.drawString(xoffset,yoffset+32,"actionrings: "+player.actionrings,flags)
-- 	v.drawString(xoffset,yoffset+40,"actioncooldown: "+player.actioncooldown,flags)

end

//-King of the Panel-
local function panelhud(v, player, cam)
	if not(player.mo and KingPanel.kingpanelmode and server) then return end
	local flags = V_HUDTRANS|V_SNAPTOBOTTOM|V_SNAPTOLEFT|V_PERPLAYER
	local xoffset = 128
	local yoffset = 176
	local text = KingPanel.paneltimer/TICRATE
-- 	local pid
	local angle
	local compass
	local color
	local panel
	local pid = KingPanel.panel_id[KingPanel.currentpanel]
	if not(KingPanel.panelwait) and pid and pid.valid then
		angle = R_PointToAngle2(player.mo.x,player.mo.y,pid.x,pid.y)-player.mo.angle
		compass = v.getSpritePatch("CMPS",A,min(8,max(1,-(angle)/ANG1/40+5))) //Angle math is weird, idk
		color = v.getColormap(TC_DEFAULT,SKINCOLOR_SILVER)
		if pid.target and pid.target.valid and pid.target.player then
			if pid.target == player.mo and not(leveltime&6) then
				color = v.getColormap(TC_DEFAULT,SKINCOLOR_YELLOW)
			else
				color = v.getColormap(TC_DEFAULT,pid.target.player.skincolor)
			end
		end
		if KingPanel.currentpanel == 1 then
			panel = v.cachePatch("BNCEIND")
		elseif KingPanel.currentpanel == 2 then
			panel = v.cachePatch("RAILIND")
		elseif KingPanel.currentpanel == 3 then
			panel = v.cachePatch("AUTOIND")
		elseif KingPanel.currentpanel == 4 then
			panel = v.cachePatch("BOMBIND")
		elseif KingPanel.currentpanel == 5 then
			panel = v.cachePatch("SCATIND")
		elseif KingPanel.currentpanel == 6 then
			panel = v.cachePatch("GRENIND")
		else //*Insert Tim Allen noises here*
			panel = v.cachePatch("INFNIND")
		end
	end
	//Draw
	v.draw(xoffset+18,yoffset-2,v.cachePatch("CURWEAP"),flags)
	if not(KingPanel.panelwait) and pid and pid.valid then
		v.draw(xoffset,yoffset,compass,flags,color)
		v.draw(xoffset+20,yoffset,panel,flags)
	end
	v.drawString(xoffset+40,yoffset+4,text,flags)
end

hud.disable("weaponrings") //No use for these anymore
hud.add(actionhud, player)
hud.add(panelhud, player)